# Forgejo

## Meta

* https://codeberg.org/forgejo
* https://codeberg.org/forgejo#meta

## Forgejo Development

* https://forgejo.org/docs/v1.21/developer/architecture/
* https://forgejo.org/docs/v1.21/developer/customization/

## UI

* https://codeberg.org/forgejo/discussions/issues/338

## Tasks

Abstimmung mit Micha (Marschner), 06.05.25:

1. Einarbeiten, Development Model, zB. Astro Framework
1. Soft-Forking, Down/Up-Streaming
1. 'Sparring' User experience

Koordination:
* Hinweis: '8 Wochen MVP Forgejo-as-a-Service' ist derzeit der Fokus auf das SaaS in der OTC
* In dieser zeit arbeitet Julius an der UX-Architekturkonzeption 
* Michael arbeitet sich ein, Technologie-Stack verstehen
* 'Zum laufen bekommen': Lokales Aufsetzen als Nächstes gemeinsam -> Termin stellt Stephan ein

## Local Development

### method 1: docker compose with forgejo:latest

Method 1: run a latest forgejo with sqlite - configuration is done on first login

* https://forgejo.org/docs/latest/admin/installation-docker/

```bash
docker compose up -d

# open localhost:3000

# check registry

docker login localhost:3000

docker image push localhost:3000/<user>/<image>
```

### method 2: install and develop it from source

* https://codeberg.org/forgejo/forgejo.git 

```bash
git clone https://codeberg.org/forgejo/forgejo.git 

# enter devcontainer in VSC (takes 10 mins for the first time)

# make build

# then run ./gitea (sic!) --help
# also see ./gitea forgejo-cli actions
```

### method 3: 'setup forgejo' (with runner)

* https://code.forgejo.org/actions/setup-forgejo

Additional links:
* https://brainsteam.co.uk/2024/03/17/moving-from-gitea-to-forgejo-including-actions-with-docker-compose/
* https://code.forgejo.org/forgejo/runner
* https://linus.dev/posts/setting-up-a-self-hosted-forgejo-actions-runner-with-docker-compose/

```bash
git clone https://code.forgejo.org/actions/setup-forgejo.git
```